#!/usr/bin/perl

#use strict;

use CGI qw /:all/;
use URI;
use Pg;

my ($conn,$user_name,$password,$line,$user_inet,
    $time,$duration,$client,$result,$bytes,$method,$url,$rfc,$hierarhy,$type,
    $day,$month,$year,
    $total_bytes,%bytes_per_day);

my($user_conn,$pass_conn);
$user_conn='user';
$pass_conn='pass';

my ($i,@args);

sub EscapeString ($){
    my ($l)=@_;
    $l =~ s/'/\\'/g;
    $l =~ s/\//\\\//g;
    $l =~ s/\*/\\\*/g;
#    $l =~ s///g;
    return $l;
}

$ENV{PATH}='/bin:/usr/bin:/sbin:/usr/sbin';

$conn=new CGI;
$total_bytes=0;
print $conn->header(-charset=>'windows-1251');
print $conn->start_html(-encoding=>'windows-1251',-lang=>'ru_RU',-title=>'  ');

if (! $conn->param()) {
    ($s_month,$s_year)=(localtime)[4,5];
    $s_month++;
    $s_year+=1900;

    print $conn->h1('     ');
    print $conn->start_form;
#    print $conn->p(" : ",$conn->textfield(-name=>'user_name',-size=>50,-maxlength=>30));
#    print $conn->p(" : ",$conn->password_field(-name=>'user_pass',-size=>50,-maxlength=>30));
    print $conn->start_table({-border=>0});
    print "<tr><td> : </td><td>",$conn->textfield(-name=>'user_name',-size=>50,-maxlength=>30),"</td></tr>\n";
    print "<tr><td> : </td><td>",$conn->password_field(-name=>'user_pass',-size=>50,-maxlength=>30),"</td></tr>\n";
    print $conn->end_table;
    print $conn->p("   : ", $conn->textfield(-name=>'s_month',-size=>3,-maxlength=>2,-default=>$s_month),"/",$conn->textfield(-name=>'s_year',-size=>5,-maxlength=>4,-default=>$s_year));
    print $conn->p($conn->checkbox(-name=>'full_print',-checked=>0,-label=>'   ?'));
    print $conn->submit(-name=>' ');
#    print $conn->end_form;
    print "<HR>\n";
    print $conn->h1(" :");
    print $conn->h4(",              ");
#    print $conn->start_form;
#    print $conn->p("   :",$conn->textfield(-name=>'to_user',-size=>50,-maxlength=>20));
#    print $conn->p("  ( ):",$conn->textfield(-name=>'to_amount',-size=>50,-maxlength=>20));
    print $conn->start_table({-border=>0});
    print "<tr><td>   :</td><td>",$conn->textfield(-name=>'to_user',-size=>50,-maxlength=>20),"</td></tr>\n";
    print "<tr><td>  ( ):</td><td>",$conn->textfield(-name=>'to_amount',-size=>50,-maxlength=>20),"</td></tr>\n";
    print $conn->end_table;
    print $conn->submit(-name=>' ');
    print $conn->end_form;
    print "<HR>\n";
    print $conn->a({-href=>'results.cgi'},'     ');
    print $conn->end_html;
    exit (0);
} else {
    $user_name=$conn->param('user_name');
#    ($user_name)=($user_name =~/([a-zA-Z]+)/);
    $user_name =~ EscapeString($user_name);
    $password=$conn->param('user_pass');
    $password=EscapeString($password);
    $cur_month=int ($conn->param('s_month')+0.5);
    $cur_year=int ($conn->param('s_year')+0.5);
    $full_print=($conn->param('full_print') eq 'on')?1:0;
    $to_user=$conn->param('to_user');
    $to_user=EscapeString($to_user);
    ($to_amount)=($conn->param('to_amount') =~/(\d+)/);
    $to_amount=0 if $to_amount eq "";
#    print $conn->p("$user_name - $password");
#    open LDAP_TEST,"/usr/bin/ldapwhoami -x -D \"uid=${user_name},ou=people,dc=bkpi82,dc=nikiet,dc=ru\" -w \"${password}\" |";
    system "/usr/bin/ldapwhoami -h 193.125.101.1 -x -D 'uid=${user_name},ou=people,dc=bkpi82,dc=nikiet,dc=ru' -w '${password}' >/dev/null";
#    print "Test info: $?";
    if ($? != 0) {
	print $conn->h1(' !!!');
	print $conn->end_html;
	exit (0);
    }
#    print "Test info";
#    print $conn->p("/usr/bin/ldapsearch -xLLL -D \"uid=${user_name},ou=people,dc=bkpi82,dc=nikiet,dc=ru\" -w \"${password}\" \"(uid=${user_name})\" |");
    open LDAP_INFO, "/usr/bin/ldapsearch -h 193.125.101.1 -xLLL -D \'uid=${user_name},ou=people,dc=bkpi82,dc=nikiet,dc=ru\' -w \'${password}\' -b \'ou=people,dc=bkpi82,dc=nikiet,dc=ru\' \'(uid=${user_name})\' |";
    $user_inet=0;
    while ($line=<LDAP_INFO>) {
	chomp $line;
	$line =~ /^(\w*):\s+(.*)/;
	$user_inet=1 if ($1 eq "destinationIndicator") && ($2 eq "internet");
    }
    close LDAP_INFO;
#    print "Test info";
    if ($user_inet==0) {
	print $conn->h1('     !!!');
	print $conn->end_html;
	exit (0);
    }
    
#    print "Test info";
    
    $db_connect=Pg::connectdb("dbname=internet user=${user_conn} password=${pass_conn}");
    if ($db_connect->status != PGRES_CONNECTION_OK) {
	print $conn->h1("   !!!  !!!");
	print $conn->end_html;
	exit(0);
    }

    if( defined $conn->param(' ')){
    $db_result=$db_connect->exec("select conn_time,file_size from connections where inet_user = '$user_name'");
    if ($db_result->resultStatus != PGRES_TUPLES_OK) {
	print $conn->h1("   !!!    !!!");
	print $conn->end_html;
	exit(0);
    }

#    ($cur_month)=(localtime())[4];

    while (@line=$db_result->fetchrow) {
	($day,$month,$year)=(localtime ($line[0]))[3,4,5];
	$month++;
	next if $cur_month != $month;
	$year+=1900;
	next if $cur_year != $year;
	$key_ref="$year-$month-$day";
	$bytes_per_day{$key_ref}+=$line[1];
	$total_bytes+=$line[1];
    }
#    print "Test info";

    $db_result=$db_connect->exec("select per_curmonth from user_quota where username = '$user_name'");
    if ($db_result->resultStatus != PGRES_TUPLES_OK) {
	print $conn->h1("   !!!    !!!");
	print $conn->end_html;
	exit(0);
    }
    
    @line=$db_result->fetchrow();
    $Curr_quota=$line[0];
    $Curr_kquota=sprintf ("%12.2f",$line[0]/1024);
    $Curr_mquota=sprintf ("%12.2f",$line[0]/1024/1024);

    print $conn->h1(" $user_name   $cur_month.$cur_year:");
    print $conn->start_table({-border=>1});
    print "<tr><th></th><th> </th><th> </th><th> </th></tr>\n";
    foreach $i (sort { my $m,$n; (undef,undef,$m)= ($a =~ m/(\d+)-(\d+)-(\d+)/); (undef,undef,$n)= ($b =~ m/(\d+)-(\d+)-(\d+)/); return $m <=> $n; } keys %bytes_per_day) {
	$i =~ m/(\d+)-(\d+)-(\d+)/;
	$j = "$3.$2.$1";
	$bytes=$bytes_per_day{$i};
	$kbytes=sprintf ("%12.2f",$bytes_per_day{$i}/1024);
	$mbytes=sprintf ("%12.2f",$bytes_per_day{$i}/1024/1024);
	print "<tr><td>$j</td><td>$mbytes</td><td>$kbytes</td><td>$bytes</td></tr>\n";
    }
#    print "<tr><td></td><td></td></tr>\n";
    $total_kbytes=sprintf ("%12.2f",$total_bytes/1024);
    $total_mbytes=sprintf ("%12.2f",$total_bytes/1024/1024);
    print "<tr><td> :</td><td>$total_mbytes</td><td>$total_kbytes</td><td>$total_bytes</td></tr>\n";
    print "<tr><td>  :</td><td>$Curr_mquota</td><td>$Curr_kquota</td><td>$Curr_quota</td></tr>\n";
    print $conn->end_table;
    if ($full_print) {
	print $conn->p("  :");
	$db_result=$db_connect->exec("select conn_time,destination,file_size from connections where inet_user = '$user_name'");
	if ($db_result->resultStatus != PGRES_TUPLES_OK) {
	    print $conn->h1("   !!!    !!!");
	    print $conn->end_html;
	    exit(0);
	}
	print $conn->start_table({-border=>1});
	print "<tr><th></th><th></th><th></th></tr>";
	$ntuples=$db_result->ntuples();
	for ($i=0;$i<$ntuples;$i++) {
	    $d1=(localtime($db_result->getvalue($i,0)))[4]+1;
	    next if $d1 != $cur_month;
	    $d1=localtime($db_result->getvalue($i,0));
	    $d1=~ s/ /&nbsp;/g;
	    $d2=$db_result->getvalue($i,1);
	    $d3=$db_result->getvalue($i,2);
	    print "<tr><td>$d1</td><td>$d2</td><td>$d3</td></tr>";
	}
	print $conn->end_table;
					    
    }
    
    }
    if(defined $conn->param(' ')){
	$db_result=$db_connect->exec("select per_curmonth,(per_curmonth-cur_value) as left_amount from user_quota where username='$user_name'");
        if ($db_result->resultStatus != PGRES_TUPLES_OK) {
    	    print $conn->h1("   !!!    !!!");
	    print $conn->end_html;
	    exit(0);
	}
	if($db_result->ntuples() != 1){
    	    print $conn->h1("    $user_name!!!");
	    print $conn->end_html;
	    exit(0);
	}
	($from_quota,$left_quota)=$db_result->fetchrow();
	if($left_quota<$to_amount) {
    	    print $conn->h1("    !!!");
	    print $conn->end_html;
	    exit(0);
	}
	$db_result=$db_connect->exec("select per_curmonth from user_quota where username='$to_user'");
        if ($db_result->resultStatus != PGRES_TUPLES_OK) {
    	    print $conn->h1("   !!!    !!!");
	    print $conn->end_html;
	    exit(0);
	}
	if($db_result->ntuples() != 1) {
    	    print $conn->h1("    $to_user!!!");
	    print $conn->end_html;
	    exit(0);
	}
	$db_result=$db_connect->exec("begin");
        if ($db_result->resultStatus != PGRES_COMMAND_OK) {
    	    print $conn->h1("     ( 1)!!!");
	    print $conn->end_html;
	    $db_connect->exec("rollback");
	    exit(0);
	}
	$db_result=$db_connect->exec("update user_quota set per_curmonth=per_curmonth-$to_amount where username='$user_name'");
        if ($db_result->resultStatus != PGRES_COMMAND_OK) {
    	    print $conn->h1("     ( 2)!!!");
	    print $conn->end_html;
	    $db_connect->exec("rollback");
	    exit(0);
	}
	$db_result=$db_connect->exec("update user_quota set per_curmonth=per_curmonth+$to_amount where username='$to_user'");
        if ($db_result->resultStatus != PGRES_COMMAND_OK) {
    	    print $conn->h1("     ( 3)!!!");
	    print $conn->end_html;
	    $db_connect->exec("rollback");
	    exit(0);
	}
	print $conn->p("   $user_name  $to_user   $to_amount  .");
	$db_connect->exec("commit");
    }
#    print "Test info";
    print $conn->end_html;
}
