#!/usr/bin/perl

use Pg;
use URI;

$username='user';
$password='pass';

$term=1;

exit (0) if -e "/var/run/access.fifo.pid";

system ("echo '$$' >/var/run/access.fifo.pid");

sub sig_handler {
$term=0;
}

sub sig_end {
    unlink "/var/run/access.fifo.pid";
    exit (0);
}

sub Register_Traffic {
    my ($User,$User_computer,$Server,$Timestamp,$File_Size)=@_;
    $result=$connect->exec("insert into connections (conn_time,inet_user,user_addr,destination,file_size) values ($Timestamp,'$User','$User_computer','$Server',$File_Size)");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
	print ACCESS_LOG "DB ERROR1!!!!\n";
    }
    $result=$connect->exec("update user_quota set cur_value=cur_value+$File_Size where username='$User'");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {	print ACCESS_LOG "DB ERROR2!!!\n";
    }
}

$connect=Pg::connectdb("dbname=internet user=${username} password=${password}");
if ($connect->status != PGERS_CONNECTION_OK) {
    print ACCESS_LOG "Postgresql database not available!!!\n";
    die;
}



$SIG{'HUP'}=\&sig_handler;
$SIG{'TERM'}=\&sig_end;
$SIG{'INT'}=\&sig_end;
#print "My pid is $$\n";
while (1) {
$term=1;
open TEST, "</var/log/squid/access.fifo" or die "Error!!!";
open ACCESS_LOG, ">>/var/log/squid/access.log";
select ACCESS_LOG; $|=1;
select STDOUT;
while (($line=<TEST>) && $term>0) {
    print ACCESS_LOG $line;
    
    chomp $line;
    ($time,$duration,$client,$result,$bytes,$method,$url,$rfc,$hierarhy,$type)=split (/\s+/,$line);
    next if ($hierarhy =~ /^NONE/ || $url =~/^cache_object:/);
    $url="https://$url" if $method eq "CONNECT" && $url !~/https:/i;
    my $uri=URI->new($url);
    $uri=$uri->canonical;
    my $host=$uri->host;
    next if $host =~ m#^193.125.101.\d\d?\d?$#;
    next if $host =~ m#.+\.bkpi82\.nikiet\.ru$#;
#Converting timestamp to day/month/year hour:minute
#    ($day,$month,$year)=(localtime ($time))[3,4,5];
#    $month++;
#    $year+=1900;

    Register_Traffic ($rfc, $client, $uri->canonical, $time, $bytes);
}
close TEST;
close ACCESS_LOG;
}
